# coding: utf-8

import sys
import numpy
import ctw

def count_symbols( name ) :
	try:
		arch = open( name, "r" )
	except:
		print "ERROR opening file ", name
		sys.exit(3)

	i=0
	s=0
	while 1:
		line = arch.readline( )
		if line == "" :
			break

		if line[0] == '#' :
			continue

		n = len( line )

		j = n-1
		cuenta=0
		while j>0 :
			if line[j] == '1' or  line[j] == '0':
				cuenta=1
				break;

			j -= 1	

		if cuenta==1 :
			s += j+1

	return s

def read_n_v2( arch, x, size ) :
	s = 1
	while 1:
		linea = arch.readline( )
		if linea == "" :
			break

		if linea[0] == '#' :
			continue

		n = len( linea )

		j = 0   # index inside the string
		while j<n :
			if linea[j] == '1' :
				x[s] = 1
				s += 1
			elif linea[j] == '0':
				x[s] = 0
				s += 1
			j += 1	

	arch.close()
	return s-1


def read_from_file( name, tree ) :

	n = count_symbols( name )
	# print "1 ", n
	tree.x = numpy.zeros( n+1, dtype=numpy.int8)
	tree.alphabet_predict = 2
	tree.alphabet = 3
	tree.epsilon = 2
	tree.beta = 1.0/float(tree.alphabet_predict)

	try:
		arch = open( nombre, "r" )
	except:
		print "ERROR opening file ", nombre
		sys.exit(2)


	m = read_n_v2( arch, tree.x, n )
	# print "2 ", m
	if m != n :
		print "ERROR: diferent number of readed symbols"
		sys.exit(3)
	arch.close()

	i = 1
	while i <= n:
		arbol.update_tree( tree.top, tree.x[i], i-1 )
		i += 1

	tree.size = n
	tree.N = i-1     # erase 1 from the last cycle

##
## El programa!
##

n = len( sys.argv )
if n != 2 :
	print "Args: filename_with_list_of_symbols"
	sys.exit(1)

nombre = sys.argv[1]

arbol = ctw.Tree( )

arbol.top = ctw.Node()

read_from_file( nombre, arbol )

print "N=", arbol.N, "L(CTW)=", arbol.top.Lw, "h(CTW)=", arbol.top.Lw/arbol.N

# n = arbol.count_total( arbol.top )
# print n
